unit Unit1;

//Programme par Yoann
//http://delphipage.free.fr/

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, OpenGl12,
  ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
   RC :HGLRC; //Adresse du contexte graphique o OpenGL dessinera
   Angle :TGLfloat; //Angle pour le mouvement
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
//Creation du contexte graphique pour notre fentre
RC:=CreateRenderingContext(Form1.Canvas.Handle,[opDoubleBuffered],32,0,0,0,0); //Travail en double tampon et en 32 bits
wglMakeCurrent(Form1.Canvas.Handle,RC); //Cration du contexte graphique pour la fentre
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
wglDeleteContext(RC); //Supprime le contexte graphique
end;

procedure TForm1.FormResize(Sender: TObject);
begin
glMatrixMode(GL_PROJECTION); //Spcifie la matrice de projection
glLoadIdentity; //Initialise la matrice de projection
gluPerspective(45,Width/Height,1,10); //Dfinit le champ de vision
glViewport(0,0,Form1.Width, Form1.Height); //Specifie l'espace disponible  l'ecran
glMatrixMode(GL_MODELVIEW);
Form1.Paint;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT); //Vide le tampon
glLoadIdentity; //Initialise la matrice de projection
glTranslatef(0,0,-10); //Translation vers les axes X,Y,Z
glPushMatrix(); //Sauvegarde la matrice active
glScalef(0.8,0.8,0.8); //Redimensionne l'objet
glTranslatef(0,0,2.0); //Translation (x,y,z)
glRotatef(Angle,1,0,0); //Rotaion suivant un angle et suivant les axes (angle,x,y,z);
glRotatef(-Angle,0,1,0);
glRotatef(-Angle,0,0,1);
glBegin(GL_QUADS);//Commence  dessiner le carr
//1 re face\\
glColor3f(1,0,0);
glVertex3f(2,2,2); //1p
glColor3f(0,0,1);
glVertex3f(2,-2,2); //2p
glColor3f(0,1,0);
glVertex3f(-2,-2,2); //3p
glColor3f(1,1,0);
glVertex3f(-2,2,2); //4p
//2 me face\\
glColor3f(1,0,0);
glVertex3f(2,2,-2); //1p
glColor3f(0,0,1);
glVertex3f(2,-2,-2); //2p
glColor3f(0,1,0);
glVertex3f(-2,-2,-2); //3p
glColor3f(1,1,0);
glVertex3f(-2,2,-2); //4p
//3 me face\\
glColor3f(1,0,0);
glVertex3f(2,2,2); //1p
glColor3f(0,0,1);
glVertex3f(2,-2,2); //2p
glColor3f(0,1,0);
glVertex3f(2,-2,-2); //3p
glColor3f(1,1,0);
glVertex3f(2,2,-2); //4p
//4 me face\\
glColor3f(1,1,0);
glVertex3f(-2,2,2); //1p
glColor3f(0,1,0);
glVertex3f(-2,-2,2); //2p
glColor3f(0,0,1);
glVertex3f(-2,-2,-2); //3p
glColor3f(1,0,0);
glVertex3f(-2,2,-2); //4p
//5 me face\\
glColor3f(0,1,0);
glVertex3f(-2,2,-2); //1p
glColor3f(1,1,0);
glVertex3f(-2,2,2); //2p
glColor3f(1,0,0);
glVertex3f(2,2,2); //3p
glColor3f(0,0,1);
glVertex3f(2,2,-2); //4p
//6 me face\\
glColor3f(1,1,0);
glVertex3f(-2,-2,-2); //1p
glColor3f(0,1,0);
glVertex3f(-2,-2,2); //2p
glColor3f(0,0,1);
glVertex3f(2,-2,2); //3p
glColor3f(1,0,0);
glVertex3f(2,-2,-2); //4p
glEnd(); //Finis de dessiner le carr
glPopMatrix(); //Recuprer la matrice prcdemment sauvegarder
SwapBuffers(Form1.Canvas.Handle); //Basculer le contenu d'un tampon dans l'autre
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
Angle := Angle + 3;
Form1.Paint;
end;

end.
